% This is "sig-alternate.tex" V2.0 May 2012
% This file should be compiled with V2.5 of "sig-alternate.cls" May 2012
%
% This example file demonstrates the use of the 'sig-alternate.cls'
% V2.5 LaTeX2e document class file. It is for those submitting
% articles to ACM Conference Proceedings WHO DO NOT WISH TO
% STRICTLY ADHERE TO THE SIGS (PUBS-BOARD-ENDORSED) STYLE.
% The 'sig-alternate.cls' file will produce a similar-looking,
% albeit, 'tighter' paper resulting in, invariably, fewer pages.
%
% ----------------------------------------------------------------------------------------------------------------
% This .tex file (and associated .cls V2.5) produces:
%       1) The Permission Statement
%       2) The Conference (location) Info information
%       3) The Copyright Line with ACM data
%       4) NO page numbers
%
% as against the acm_proc_article-sp.cls file which
% DOES NOT produce 1) thru' 3) above.
%
% Using 'sig-alternate.cls' you have control, however, from within
% the source .tex file, over both the CopyrightYear
% (defaulted to 200X) and the ACM Copyright Data
% (defaulted to X-XXXXX-XX-X/XX/XX).
% e.g.
% \CopyrightYear{2007} will cause 2007 to appear in the copyright line.
% \crdata{0-12345-67-8/90/12} will cause 0-12345-67-8/90/12 to appear in the copyright line.
%
% ---------------------------------------------------------------------------------------------------------------
% This .tex source is an example which *does* use
% the .bib file (from which the .bbl file % is produced).
% REMEMBER HOWEVER: After having produced the .bbl file,
% and prior to final submission, you *NEED* to 'insert'
% your .bbl file into your source .tex file so as to provide
% ONE 'self-contained' source file.
%
% ================= IF YOU HAVE QUESTIONS =======================
% Questions regarding the SIGS styles, SIGS policies and
% procedures, Conferences etc. should be sent to
% Adrienne Griscti (griscti@acm.org)
%
% Technical questions _only_ to
% Gerald Murray (murray@hq.acm.org)
% ===============================================================
%
% For tracking purposes - this is V2.0 - May 2012

\documentclass{sig-alternate}

\usepackage{url}
\usepackage{multirow}
\usepackage{enumitem}
\usepackage{moresize}
\usepackage{epstopdf}
%\ifCLASSINFOpdf
%  \usepackage[pdftex]{graphicx}
%\else
%  \usepackage[dvips]{graphicx}
%\fi
\usepackage{graphicx}
\usepackage{amsmath}

%\usepackage{caption}
%\usepackage{subcaption}

%for print java source code
\usepackage{listings}
\usepackage{color}
\definecolor{sh_comment}{rgb}{0.12, 0.38, 0.18 } %adjusted, in Eclipse: {0.25, 0.42, 0.30 } = #3F6A4D
\definecolor{sh_keyword}{rgb}{0.37, 0.08, 0.25}  % #5F1441
\definecolor{sh_string}{rgb}{0.06, 0.10, 0.98} % #101AF9
\definecolor{light-gray}{gray}{0.80}
\lstset {
% frame=single, 
% frame=lines,
tabsize=1,
 rulesepcolor=\color{black},
 showspaces=false,showtabs=false,tabsize=2,
 numberstyle=\tiny,numbers=left,
% basicstyle= \scriptsize\ttfamily,
 basicstyle= \ssmall\ttfamily,
 stringstyle=\color{sh_string},
 keywordstyle = \color{sh_keyword}\bfseries,
 commentstyle=\color{sh_comment}\itshape,
 captionpos=b,
 xleftmargin=0.7cm, xrightmargin=0.5cm,
 lineskip=-0.3em,
% escapebegin={!}, escapeend={!}
}
\lstset{framextopmargin=50pt,frame=bottomline}


\begin{document}
\lstset{language=Java}
%
% --- Author Metadata here ---
%\CopyrightYear{2007} % Allows default copyright year (20XX) to be over-ridden - IF NEED BE.
%\crdata{0-12345-67-8/90/01}  % Allows default copyright data (0-89791-88-6/97/05) to be over-ridden - IF NEED BE.
% --- End of Author Metadata ---
\numberofauthors{6}
\author{
\alignauthor
Lei Ma\\
%\titlenote{Dr.~Trovato insisted his name be first.}\\
       \affaddr{The University of Tokyo, Japan}\\
%       \affaddr{1932 Wallamaloo Lane}\\
%       \affaddr{Wallamaloo, New Zealand}\\
       \email{malei@satolab.itc.u-tokyo.ac.jp}
% 2nd. author
\alignauthor
Cyrille Artho\\
%\titlenote{The secretary disavows
%any knowledge of this author's actions.}\\
       \affaddr{AIST / RISEC, Japan}\\
%       \affaddr{P.O. Box 1212}\\
%       \affaddr{Dublin, Ohio 43017-6221}\\
       \email{c.artho@aist.go.jp}
% 3rd. author
\alignauthor 
Hiroyuki Sato\\
%Lars Th{\o}rv{\"a}ld\titlenote{This author is the
%one who did all the really hard work.}\\
       \affaddr{The University of Tokyo, Japan}\\
%       \affaddr{1 Th{\o}rv{\"a}ld Circle}\\
%       \affaddr{Hekla, Iceland}\\
       \email{schuko@satolab.itc.u-tokyo.ac.jp}
\and  % use '\and' if you need 'another row' of author names
% 4th. author
\alignauthor Johannes Gmeiner\\
       \affaddr{Software Competence Center Hagenberg, Austria}\\
%       \affaddr{Brookhaven National Lab}\\
%       \affaddr{P.O. Box 5000}\\
       \email{johannes.gmeiner@scch.at}
% 5th. author
\alignauthor Rudolf Ramler\\
       \affaddr{Software Competence Center Hagenberg, Austria}\\
%       \affaddr{Moffett Field}\\
%       \affaddr{California 94035}\\
       \email{rudolf.ramler@scch.at}
% 6th. author
\alignauthor Cheng Zhang\\
       \affaddr{University of Waterloo, Canada}\\
%       \affaddr{8600 Datapoint Drive}\\
%       \affaddr{San Antonio, Texas 78229}\\
       \email{c16zhang@uwaterloo.ca}
}

\title{Enhancing Random Testing via Run-time Guidance}

% There's nothing stopping you putting the seventh, eighth, etc.
% author on the opening page (as the 'third row') but we ask,
% for aesthetic reasons that you place these 'additional authors'
% in the \additional authors block, viz.
%\additionalauthors{Additional authors: John Smith (The Th{\o}rv{\"a}ld Group,
%email: {\texttt{jsmith@affiliation.org}}) and Julius P.~Kumquat
%(The Kumquat Consortium, email: {\texttt{jpkumquat@consortium.net}}).}
%\date{30 July 1999}
% Just remember to make sure that the TOTAL number of authors
% is the number that will appear on the first page PLUS the
% number that will appear in the \additionalauthors section.

\maketitle
\begin{abstract}
In this paper, we propose Guided Random Testing (GRT),
a demand-driven and run-time-guided approach to push the limits of random
testing.
Similar to most random testing techniques, our approach is fully automated.
GRT first performs static analysis on the classes under test, to extract domain 
knowledge such as constants, method dependencies and side effects. 
The results of static analysis enable run-time optimizations for selecting
better parameter values and candidate methods to test.
GRT improves test coverage further through state fuzzing, by
favoring methods with lower coverage, and by constructing objects as
input for methods to be tested when necessary.
We implement the six components of GRT 
as pluggable options based on Randoop. As demonstrated on 30 real-world 
projects, GRT outperforms major peer techniques in terms of code coverage (by
6\%--11\%) and mutation score~(by 9\%--10\%).
In an in-depth evaluation on ten of these projects, GRT is also
successfully detected 21 unknown defects that were confirmed by developers.
Furthermore, on a benchmark containing carefully 
seeded faults, GRT detects 3 unique faults that are missed by other techniques.
\end{abstract}

\category{D.2.5}{Software Engineering}{Testing and Debugging}
[Testing Tools, Diagnostics, Tracing]

\terms{Software reliability and quality assurance, Empirical studies} 

\keywords{Automatic test generation, random testing, static analysis, dynamic analysis}


% A category with the (minimum) three required fields
%need to be confirmed
%\category{H.4}{Information Systems Applications}{Miscellaneous}
%A category including the fourth, optional field follows...
%\category{D.2.5}{Software Engineering}{Testing and Debugging}
%[Testing Tools, Diagnostics, Tracing]

%\terms{Software reliability and quality assurance, Empirical studies} 

%\keywords{Automatic test generation, random testing, static analysis, dynamic analysis}

\renewcommand{\textfraction}{0.1}
\renewcommand{\topfraction}{0.8}
\renewcommand{\bottomfraction}{0.8}
\renewcommand{\floatpagefraction}{0.75}


\input{Section1}

\input{Section2}

\input{Section3}

\input{Section4}

\input{Section5}

\input{Conclusion}


%ACKNOWLEDGMENTS are optional
\section{Acknowledgments}
We thank Sai Zhang for his insightful comments
to improve the paper and discussion on Palus.
We thank Naoto Yokoyama for evaluating
the experimental data. Thanks also go to Gordon Fraser for his help on the configurations to run Evosuite. 

%This work was supported by the 
%$\lceil$SEUT$\rfloor$ Program
%from the University of Tokyo.
%
% The following two commands are all you need in the
% initial runs of your .tex file to
% produce the bibliography for the citations in your paper.


%\newcommand{\BIBdecl}{\setlength{\itemsep}{0.25 em}}
\clearpage

\bibliographystyle{abbrv}
\bibliography{biblio}  % sigproc.bib is the name of the Bibliography in this case
%% You must have a proper ".bib" file
%%  and remember to run:
%% latex bibtex latex latex
%% to resolve all references
%%
%% ACM needs 'a single self-contained file'!
%%
%%APPENDICES are optional
%%\balancecolumns
%\appendix
%%Appendix A
%\section{Headings in Appendices}
%The rules about hierarchical headings discussed above for
%the body of the article are different in the appendices.
%In the \textbf{appendix} environment, the command
%\textbf{section} is used to
%indicate the start of each Appendix, with alphabetic order
%designation (i.e. the first is A, the second B, etc.) and
%a title (if you include one).  So, if you need
%hierarchical structure
%\textit{within} an Appendix, start with \textbf{subsection} as the
%highest level. Here is an outline of the body of this
%document in Appendix-appropriate form:
%\subsection{Introduction}
%\subsection{The Body of the Paper}
%\subsubsection{Type Changes and  Special Characters}
%\subsubsection{Math Equations}
%\paragraph{Inline (In-text) Equations}
%\paragraph{Display Equations}
%\subsubsection{Citations}
%\subsubsection{Tables}
%\subsubsection{Figures}
%\subsubsection{Theorem-like Constructs}
%\subsubsection*{A Caveat for the \TeX\ Expert}
%\subsection{Conclusions}
%\subsection{Acknowledgments}
%\subsection{Additional Authors}
%This section is inserted by \LaTeX; you do not insert it.
%You just add the names and information in the
%\texttt{{\char'134}additionalauthors} command at the start
%of the document.
%\subsection{References}
%Generated by bibtex from your ~.bib file.  Run latex,
%then bibtex, then latex twice (to resolve references)
%to create the ~.bbl file.  Insert that ~.bbl file into
%the .tex source file and comment out
%the command \texttt{{\char'134}thebibliography}.
%% This next section command marks the start of
%% Appendix B, and does not continue the present hierarchy
%\section{More Help for the Hardy}
%The sig-alternate.cls file itself is chock-full of succinct
%and helpful comments.  If you consider yourself a moderately
%experienced to expert user of \LaTeX, you may find reading
%it useful but please remember not to change it.
%\balancecolumns % GM June 2007
% That's all folks!
\end{document}
